
/*
 * $Id: ErrorStrTbl.h,v 1.3 1999/09/07 17:46:55 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_ERROR_STRING_TABLE_H
#define PG_ERROR_STRING_TABLE_H

#include "Array.h"
#include "String.h"
#include "LogObj.h"


// holds explanatory strings for errnos
class ErrorStrTbl: public LogObj, protected Array<String*> {
	public:
		ErrorStrTbl(); // will add "system" error strings
		virtual ~ErrorStrTbl();

		int maxErrNo() const;
		const String &operator [](int errNo) const;

		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

	protected:
		String &str(int errNo);

	private:
		void fillUpTo(int lastIdx);

	private:
		String theErrnoErrStr; // returned for bad errnos
};

#endif
