/* 
 * %%nomodsWarning
 */

/*
 * $Id: gparserc.tpl,v 1.3 1999/09/07 17:59:44 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "PglSemx.h"
#include "PglParser.h"

typedef PglSemx LangSemx;

%%prelude

%%attrdef

%%code

PglParser::PglParser(Lexer *l) : GParser(l) {
	static int _condTable[] = %%condTable;

	acceptState = %%acceptState;
	condTable = _condTable;
	maxState = %%states;

	PglSemx::Init();
}

PglParser::~PglParser() {
	PglSemx::Done();
}

int PglParser::actionTable(int state, int sym) {
	static int _actionTable[%%states][%%symbols] = %%actionTable;
	return _actionTable[state][sym];
}

ReduceInfo *PglParser::reduceTable(int i) {
	static ReduceInfo _reduceTable[] = %%reduceTable;
	return(&_reduceTable[i]);
}

%%postlude
