
/*
 * $Id: AgentArrIter.h,v 1.1.2.1 1999/09/30 19:38:46 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_AGENT_ARRAY_ITERATOR_H
#define PG_AGENT_ARRAY_ITERATOR_H

#include "Array.h"
#include "NetAddr.h"

class AgentSym;

// an agent may be placed on many hosts wich makes
// it cumbersome to iterate through all agents and all hosts
// agent array iterator solves the problem
class AgentArrIter {
	public:
		AgentArrIter();
		AgentArrIter(Array<AgentSym*> *anArr, const String &anAgentType = 0);

		AgentArrIter &start(Array<AgentSym*> *anArr);

		bool eof() const;
		operator void *() const;
		AgentArrIter &operator ++();

		const NetAddr &host(); // current host
		AgentSym *agent();     // current agent

	protected:
		void sync();

	protected:
		Array<AgentSym*> *theArr;   // array to iterate
		String theAgentType;        // iterate through agents of this type
		NetAddr theHost;            // cached value
		int theAgentIdx;
		int theHostIdx;
};

#endif
