
/*
 * $Id: polyVersion.cc,v 1.12.2.3 1999/10/20 21:27:19 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "polyVersion.h"

// sync this and remake executables whenever release name changes!
#define POLY_VERSION_STR "2.2.2"

// for use with ident-like scanners
static String PolyVerIdentStr = 
	"$Polygraph: " POLY_VERSION_STR " $";
static String PolyCompTimestampIdentStr = 
	"$CompilationTimestamp: " __DATE__ " " __TIME__ " $";

const String &PolyVersion() {
	Assert(PolyVerIdentStr); // just to use it somewhere
	Assert(PolyCompTimestampIdentStr); // just to use it somewhere
	static String vs = POLY_VERSION_STR;
	return vs;
}

const String &PolyCompDate() {
	static String ds = __DATE__;
	return ds;
}

const String &PolyCompTime() {
	static String ts = __TIME__;
	return ts;
}

const String &PolyLetterhd() {
	static String lh =
		"Polygraph " POLY_VERSION_STR
		"       Copyright (C) 1998, 1999.\n"
		"Distributed without any warranty, even implied. \n"
		"See  http://polygraph.ircache.net/ for details.";
	return lh;
}
