
/*
 * $Id: SynSymTbl.cc,v 1.4 1999/09/07 17:48:17 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xparser.h"

#include "String.h"
#include "SynSymTbl.h"


/* SynSymTblItem */

SynSymTblItem::SynSymTblItem(): theSym(0), theUseCnt(0) {
}

SynSymTblItem::SynSymTblItem(const String &aType, const String &aName):
	theSym(0), theName(aName), theType(aType), theUseCnt(0) {
}

SynSymTblItem::~SynSymTblItem() {
	delete theSym;
}



/* SynSymTbl */

SynSymTbl::SynSymTbl() {
}

SynSymTbl::~SynSymTbl() {
	for (int i = 0; i < count(); ++i)
		delete valAt(i);
}

void SynSymTbl::report(ostream &os, const String &pfx) const {

	for (int i = 0; i < count(); ++i) {
		if (valAt(i)) {
			os << pfx << valAt(i)->name() << " = ";
			if (valAt(i)->sym())
				valAt(i)->sym()->print(os, pfx);
			else
				os << "undef()";
			os << ';' << endl;
		}
	}
}
